from django.shortcuts import render ,redirect
from articlescommandee.models import ArticleCommandee
from commandes.models import Commande
from colis.forms import ColisForm , form_validation_error
from colis.models import Colis
from detailscolis.models import DetailsColis
from django.contrib import messages
from commandes.models import Commande
from clients.models import Client
from django.core.serializers import serialize
from django.core import serializers
from django.http import JsonResponse
import decimal
from django.contrib.auth.decorators import login_required
import json
from articles.models import Article
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from django.views import View
from xhtml2pdf import pisa
from facturesdavoir.views import  render_to_pdf
from django.db.models import Q
# Create your views here.
@login_required(login_url="/login/")
def afficher_liste_colis(request):
	context = {}
	liste_colis = Colis.objects.all()
	for colis in liste_colis :
		if colis.qantite == 0 :
			liste_details_colis = DetailsColis.objects.filter(colis = colis)
			qantite_total  = 0 
			for detailscolis in liste_details_colis  :
				qantite_total = detailscolis.qantite + qantite_total
			Colis.objects.filter(id = colis.id).update(qantite = qantite_total)	

	context['liste_colis'] = Colis.objects.all().order_by('date').reverse()
	context['segment'] = 'colis'

	return render(request, 'liste-colis.html', context)
@login_required(login_url="/login/")
def affiche_ajouter_colis(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		colisf = Colis.objects.all().order_by('date').reverse().first()
		if colisf  :
			context['num_colis'] = '00'+ str(int(colisf.num_colis) + 1)
		else :
			context['num_colis']  = '001'
			
		articlecommandee = ArticleCommandee.objects.all().filter(commande=commande).order_by('created_at') 
		new_liste = []

		for i in range(len(articlecommandee)):
			if articlecommandee[i].article :
				art = articlecommandee[i].article.id
				if len(new_liste) > 0 : 
					for j in range(len(new_liste)) :
						if new_liste[j].article :
							if art == new_liste[j].article.id  : 
								new_liste[j].qantite_total = new_liste[j].qantite_total + articlecommandee[i].qantite_total
								new_liste[j].emballee = new_liste[j].emballee + articlecommandee[i].emballee
								new_liste[j].reste_emballee = new_liste[j].reste_emballee + articlecommandee[i].reste_emballee

				new_liste.append(articlecommandee[i])			
			else :
				new_liste.append(articlecommandee[i])
		context['articlecommandee'] = new_liste
		context['commande'] = commande
	return render(request, 'creer-colis.html', context)

@login_required(login_url="/login/")
def ajouter_colis(request):
	context = {}
	if request.method == "POST":
		articleCommande = request.POST.getlist('article_options[]')
		qantite_emballer = request.POST.getlist('qantite_emballer[]')
		form = ColisForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_colis = Colis.objects.last().id
			colis = Colis.objects.get(id = last_colis)
			Colis.objects.filter(id = last_colis).update(status = "NON EXPEDIE")
			qantite_total_emballee =0

			for i in range(len(qantite_emballer)):
				if decimal.Decimal(qantite_emballer[i]) > 0 :
					articlecommande = ArticleCommandee.objects.get( id = articleCommande[i])
					if articlecommande.reste_emballee >= decimal.Decimal(qantite_emballer[i]):
							detailscolis = DetailsColis(colis = colis , articlecommandee = articlecommande,qantite=decimal.Decimal(qantite_emballer[i]))
							detailscolis.save()
							dif_qt = articlecommande.reste_emballee - decimal.Decimal(qantite_emballer[i])
							qt_emballee = articlecommande.emballee + decimal.Decimal(qantite_emballer[i])
							qt_r2_emballee = articlecommande.qantite_total - qt_emballee

							ArticleCommandee.objects.filter(id = articlecommande.id).update(emballee = qt_emballee)
							ArticleCommandee.objects.filter(id = articlecommande.id).update(reste_emballee = qt_r2_emballee)
					# else :
					# 	dif = decimal.Decimal(qantite_emballer[i]) - articlecommande.reste_emballee
					# 	if articlecommande.reste_emballee > 0 :
					# 		detailscolis = DetailsColis(colis = colis , articlecommandee = articlecommande,qantite=articlecommande.reste_emballee)
					# 		detailscolis.save()
							
					# 		dif_qt = decimal.Decimal(qantite_emballer[i])- articlecommande.reste_emballee 
					# 		qt_emballee = articlecommande.emballee + articlecommande.reste_emballee
					# 		qt_r2_emballee = articlecommande.qantite_total - qt_emballee
					# 		ArticleCommandee.objects.filter(id = articlecommande.id).update(emballee = qt_emballee)
					# 		ArticleCommandee.objects.filter(id = articlecommande.id).update(reste_emballee = qt_r2_emballee)
						# list_article_commande = ArticleCommandee.objects.filter(commande=articlecommande.commande).filter(article = articlecommande.article).exclude(id = articleCommande[i] )
						# j = 0
						# while dif > 0 and j < len(list_article_commande):	
						# 		if list_article_commande[j].reste_emballee > 0 :
						# 			if dif >= list_article_commande[j].reste_emballee :
						# 				detailscolis2 = DetailsColis(colis = colis , articlecommandee = list_article_commande[j] , qantite=list_article_commande[j].reste_emballee)
						# 				detailscolis2.save()
						# 				dif = dif - list_article_commande[j].reste_emballee
						# 				qant2 = list_article_commande[j].emballee + list_article_commande[j].reste_emballee
						# 				ArticleCommandee.objects.filter(id = list_article_commande[j].id).update(emballee = qant2)
						# 				artcommande2 = ArticleCommandee.objects.get(id = list_article_commande[j].id)
						# 				qt_r2 = artcommande2.qantite_total - artcommande2.emballee
						# 				ArticleCommandee.objects.filter(id = list_article_commande[j].id).update(reste_emballee = qt_r2)
						# 			else :
						# 				detailscolis2 = DetailsColis(colis = colis , articlecommandee = list_article_commande[j] , qantite=dif)
						# 				detailscolis2.save()
						# 				dif = list_article_commande[j].reste_emballee - dif
						# 				qant2 = list_article_commande[j].emballee + dif
						# 				ArticleCommandee.objects.filter(id = list_article_commande[j].id).update(emballee = qant2)
						# 				artcommande2 = ArticleCommandee.objects.get(id = list_article_commande[j].id)
						# 				qt_r2 = artcommande2.qantite_total - artcommande2.emballee
						# 				ArticleCommandee.objects.filter(id = list_article_commande[j].id).update(reste_emballee = qt_r2)
						# 		       j = j+1		
			id_commande = request.POST.get('commande')
			print(id_commande)
			commande = Commande.objects.get(id = id_commande)
			final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
			rest_emballee_total = 0
			qantite_total = 0
			for arf in final_list_articla_commande :
				rest_emballee_total = rest_emballee_total + arf.reste_emballee
				qantite_total = qantite_total + arf.qantite_total

			if rest_emballee_total == 0  :
				Commande.objects.filter(id = id_commande).update(emballage = 'emballee')
			elif rest_emballee_total == qantite_total :
				Commande.objects.filter(id = id_commande).update(emballage = 'non emballe')
			else :
				Commande.objects.filter(id = id_commande).update(emballage = 'partiellement emballe')


			messages.success(request, 'colis a été bien ajouté')	
		else :
			messages.error(request, 'colis n est pas ajoute')	
	return redirect('liste_commandes')

@login_required(login_url="/login/")		
def afficher_colis(request , id_colis):
    idcolis = int(id_colis)
    colis = Colis.objects.get(id=idcolis)
    detailscolis = DetailsColis.objects.filter(colis = colis)
    context = {}
    context['colis'] = colis
    new_liste = []
    for i in range(len(detailscolis)):
    	if detailscolis[i].articlecommandee.article :
    		art = detailscolis[i].articlecommandee.article.id
    		if len(new_liste) > 0 :
    			for j in range(len(new_liste)) :
    				if detailscolis[i].articlecommandee.article :
    					if art == new_liste[j].articlecommandee.article.id  :
    						new_liste[j].qantite = new_liste[j].qantite + detailscolis[i].qantite
    		new_liste.append(detailscolis[i])
    	else :
    		new_liste.append(detailscolis[i])
    context['article_colis'] = new_liste

    return render(request, 'afficher-colis.html', context)

@login_required(login_url="/login/")
def afficher_ajouter_colis_colis(request):
	context ={}
	context['liste_clients'] = Client.objects.all()
	context['liste_commandes'] = Commande.objects.all().filter( Q(emballage='partiellement emballe') | Q(emballage='non emballe')).filter(type_commande ='commande')
	
	return render(request, 'ajouter-colis.html', context)

@login_required(login_url="/login/")
def getArticleCommande(request):
    if request.is_ajax and request.method == "GET":

        id_commande = request.GET.get("id_commande", None)
        commande = Commande.objects.get(id = id_commande)
        print(commande)
        articlecommandee = ArticleCommandee.objects.all().filter(commande = commande).exclude(reste_emballee = 0)

        colisf = Colis.objects.all().order_by('date').reverse().first()
        if colisf  :
        	num_colis = '00'+ str(int(colisf.num_colis) + 1)
        else :
        	num_colis = '001'
        new_liste = {}  
        for i in range(len(articlecommandee)):
        	if articlecommandee[i].article :
        		art = articlecommandee[i].article.id
        		article = Article.objects.get(id = art)
        		lisd = {'article' : article.nom_article,'type':'article','id_article' : str(articlecommandee[i].id),'qantite_total' : str(articlecommandee[i].qantite_total) , 'emballee' :str(articlecommandee[i].emballee ) ,'reste_emballee' :str(articlecommandee[i].reste_emballee) ,'num_colis':num_colis}
        		new_liste[i] = lisd

        data= json.dumps(new_liste)
        return JsonResponse({"data":data}, status = 200)
    return JsonResponse({}, status = 400)	

@login_required(login_url="/login/")		
def afficher_modifier_colis(request ):
	if request.method == "POST":
		idcolis = request.POST.get('colis')
		colis = Colis.objects.get(id = idcolis)
		detailscolis = DetailsColis.objects.filter(colis = colis)
		context = {}
		context['colis'] = colis
		new_liste = []
		for i in range(len(detailscolis)):
			if detailscolis[i].articlecommandee.article :
				art = detailscolis[i].articlecommandee.article.id
				if len(new_liste) > 0 :
					for j in range(len(new_liste)) :
						if detailscolis[i].articlecommandee.article :
							if art == new_liste[j].articlecommandee.article.id  :
								new_liste[j].qantite = new_liste[j].qantite + detailscolis[i].qantite
				new_liste.append(detailscolis[i])
			else :
				new_liste.append(detailscolis[i])
		context['article_colis'] = new_liste
	return render(request, 'modifier-colis.html', context)


@login_required(login_url="/login/")		
def valider_modifier_colis(request ):
	if request.method == "POST":
		idcolis = request.POST.get('colis')
		colis = Colis.objects.get(id = idcolis)

		liste_details = request.POST.getlist('colisdetails_options[]')
		liste_qantite_emballer = request.POST.getlist('qantite_emballer[]')
		num_colis = request.POST.get('num_colis')
		date = request.POST.get('date')
		date_de_livraison = request.POST.get('date_de_livraison')
		if date :
			Colis.objects.filter(id = idcolis).update(date = date)
		if date_de_livraison :
			Colis.objects.filter(id = idcolis).update(date_de_livraison = date_de_livraison)
		Colis.objects.filter(id = idcolis).update(num_colis = num_colis)

		qantite_total = 0 
		for i in range(len(liste_details)) :
			detailscolis = DetailsColis.objects.get(id = liste_details[i])
			qantite_prec = detailscolis.qantite
			artclecomm = ArticleCommandee.objects.get(id = detailscolis.articlecommandee.id)

			if decimal.Decimal(liste_qantite_emballer[i]) > qantite_prec :
				diff = decimal.Decimal(liste_qantite_emballer[i]) - qantite_prec
				emballee = artclecomm.emballee + diff
				reste_emballee = artclecomm.reste_emballee - diff
			else :
				diff = qantite_prec - decimal.Decimal(liste_qantite_emballer[i])
				emballee = artclecomm.emballee - diff
				reste_emballee = artclecomm.reste_emballee + diff
			ArticleCommandee.objects.filter(id = artclecomm.id).update(emballee = emballee)
			ArticleCommandee.objects.filter(id = artclecomm.id).update(reste_emballee = reste_emballee)

			if decimal.Decimal(liste_qantite_emballer[i]) == 0 :
				detailscolis.delete()
			else :
				qantite_total = qantite_total + decimal.Decimal(liste_qantite_emballer[i])
				DetailsColis.objects.filter(id = liste_details[i]).update(qantite = liste_qantite_emballer[i])

		Colis.objects.filter(id = idcolis).update(qantite = qantite_total)
		commande = Commande.objects.get(id = colis.commande.id)
		final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
		rest_emballee_total = 0
		qantite_com = 0 
		for arf in final_list_articla_commande :
			rest_emballee_total = rest_emballee_total + arf.reste_emballee
			qantite_com =  qantite_com + arf.qantite_total

			if rest_emballee_total == 0  :
				Commande.objects.filter(id = colis.commande.id).update(emballage = 'emballee')
			elif qantite_com ==  rest_emballee_total :
				Commande.objects.filter(id = colis.commande.id).update(emballage = 'non emballe')
			else :
				Commande.objects.filter(id = colis.commande.id).update(emballage = 'partiellement emballe')
		
	return redirect('afficher_liste_colis')



@login_required(login_url="/login/")		
def supprimer_colis(request ):
	if request.method == "POST":
		idcolis = request.POST.get('colis')
		colis = Colis.objects.get(id = idcolis)
		detailscolis = DetailsColis.objects.filter(colis = colis)

		for i in range(len(detailscolis)) :

			artclecomm = ArticleCommandee.objects.get(id = detailscolis[i].articlecommandee.id)
			emballee = artclecomm.emballee - detailscolis[i].qantite
			reste_emballee = artclecomm.reste_emballee + detailscolis[i].qantite

			ArticleCommandee.objects.filter(id = artclecomm.id).update(emballee = emballee)
			ArticleCommandee.objects.filter(id = artclecomm.id).update(reste_emballee = reste_emballee)

		colis.delete()

		commande = Commande.objects.get(id = colis.commande.id)
		final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
		rest_emballee_total = 0
		qantite_com = 0 
		for arf in final_list_articla_commande :
			rest_emballee_total = rest_emballee_total + arf.reste_emballee
			qantite_com =  qantite_com + arf.qantite_total
			if rest_emballee_total == 0  :
				Commande.objects.filter(id = commande.id).update(emballage = 'emballee')
			elif qantite_com ==  rest_emballee_total :
				Commande.objects.filter(id = commande.id).update(emballage = 'non emballe')
			else :
				Commande.objects.filter(id = commande.id).update(emballage = 'partiellement emballe')
		
		messages.success(request, 'colis a été bien supprimer')	

	return redirect('afficher_liste_colis')	


class ViewPDFColis(View):
	def get(self, request, *args, **kwargs):
		id_colis = request.GET.get('id_colis')
		type_pdf = request.GET.get('type')

		print('id ',id_colis)
		data = {
			"colis": Colis.objects.get(id = id_colis),
			"detailsColis": DetailsColis.objects.filter(colis_id = id_colis),
		}
		if type_pdf == 'colis' :
			pdf = render_to_pdf('colis.html', data)
		else :
			pdf = render_to_pdf('livraison.html', data)

		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFColis(View):
	def get(self, request,*args,**kwargs):
		id_colis = request.GET.get('id_colis')
		type_pdf = request.GET.get('type')

		print('id ',id_colis)
		data = {
			"colis": Colis.objects.get(id = id_colis),
			"detailsColis": DetailsColis.objects.filter(colis_id = id_colis),
		}
		if type_pdf == 'colis' :
			pdf = render_to_pdf('colis.html', data)
		else :
			pdf = render_to_pdf('livraison.html', data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= colis.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response
